// Cory McWilliams
// mcwilc@rpi.edu
// 10/15/2004
// (Modified from code given for project)

#ifndef _PROJ2_SUPPORT_H_
#define _PROJ2_SUPPORT_H_

//the numbers are the dimensions of the bounding box
//of the ellipsoids corresponding to each body part
#define TORSO_WIDTH 2.0 
#define TORSO_HEIGHT 3.0
#define TORSO_DEPTH 0.8

#define UPPER_ARM_WIDTH 0.6
#define UPPER_ARM_HEIGHT 1.5
#define UPPER_ARM_DEPTH 0.6

#define LOWER_ARM_WIDTH 0.5
#define LOWER_ARM_HEIGHT 1.5
#define LOWER_ARM_DEPTH 0.5

#define HEAD_WIDTH 1.2
#define HEAD_HEIGHT 1.5
#define HEAD_DEPTH 1

#define NECK_WIDTH 0.5
#define NECK_HEIGHT 0.5
#define NECK_DEPTH 0.5

#define SHOULDER_WIDTH 0.5
#define SHOULDER_HEIGHT 0.5
#define SHOULDER_DEPTH 0.5

#define HIP_WIDTH 2.0
#define HIP_HEIGHT 1.0
#define HIP_DEPTH 0.8

#define UPPER_LEG_WIDTH 0.8
#define UPPER_LEG_HEIGHT 2.5
#define UPPER_LEG_DEPTH 0.6

#define LOWER_LEG_WIDTH 0.7
#define LOWER_LEG_HEIGHT 2.0
#define LOWER_LEG_DEPTH 0.4

#include <vector>
#include <fstream>
#include <iostream>

class animation_handler
{
	std::vector<float*> data;
public:
	animation_handler(const char *filename) {
		std::ifstream inf(filename);
		if(!inf)
		{
			std::cerr << "Error loading file: " << filename << '\n';
			return;
		}
		while(inf)
		{
			float *angles = new float[13];
			for (int i = 0; i < 13; i++) {
				if (!(inf >> angles[i])) {
					break;
				}
			}
			if (inf) {
				data.push_back(angles);
			}
		}
		std::cout << filename << " animation loaded.\n";
	}
	~animation_handler() {
		for (size_t i = 0; i < data.size(); i++) {
			delete[] data[i];
		}
	}
	float *operator[](size_t index) {
		return data[index];
	}
	size_t size() {
		return data.size();
	}
};

#endif
