// Cory McWilliams
// mcwilc@rpi.edu
// 10/15/2004

#ifndef _HUMANOID_H_
#define _HUMANOID_H_

#define HUMANOID_JOINT_COUNT 14

#if defined (__APPLE__)
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include "proj2_support.h"

class Humanoid {
	float mCurrentRotations[HUMANOID_JOINT_COUNT];
	GLUquadric *mQuadric;
	float mJoint[HUMANOID_JOINT_COUNT];
	animation_handler *mAnimation;
	int mFrame;
	float mTime;
	void (*mHolding)();
public:
	enum Joint {
		Joint_Head, Joint_Neck, Joint_Torso,
		Joint_LeftShoulder, Joint_LeftUpperArm, Joint_LeftLowerArm,
		Joint_RightShoulder, Joint_RightUpperArm, Joint_RightLowerArm,
		Joint_LeftUpperLeg, Joint_LeftLowerLeg,
		Joint_RightUpperLeg, Joint_RightLowerLeg,
		Joint_Hip
	};

	Humanoid();
	~Humanoid();
	void draw();
	void step();
	void loopAnimation(const char *filename);
	float joint(int index) { return mJoint[index]; }
	void joint(int index, float value) { mJoint[index] = value; }
	float catmullRomAngle(float v1, float v2, float v3, float v4, float t);
	void dump();
	void reset();
	bool lastFrame();
	void hold(void (*holding)());
};

#endif
